#include <gmp.h>
#include <stdio.h>
#include <stdlib.h>

#define SIZE(x) (x[0]._mp_size)
#define DATA(x) (x[0]._mp_d)

int main()
{
   mpz_t d, a, b, xa;

   mp_size_t sxa;

   mpz_init2(d, 5000);
   mpz_init2(a, 5000);
   mpz_init2(b, 5000);
   mpz_init2(xa, 5000);


   mpz_inp_str(a, NULL, 0);
   mpz_inp_str(b, NULL, 0);

   SIZE(d) = 
      mpn_gcdext(DATA(d), 
                 DATA(xa), &sxa,
                 DATA(a), SIZE(a), 
                 DATA(b), SIZE(b));

   printf("%ld %ld\n", (long) sxa, DATA(xa)[labs(sxa)-1]);

   return 0;
}
